//+------------------------------------------------------------------+
//|                                                     trend_v3.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Blue


extern int period =52;
extern bool Show_nNoncomm=false;
extern bool Show_nOperators=true;
extern bool Show_nNonrep=false;
extern bool Show_nOI=false;
double A[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   SetIndexBuffer(0,A);
   SetIndexDrawBegin(0,0);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {

   int    counted_bars=IndicatorCounted();
   int   i, j, k, q, limit,N;
   double X[2][2], Y[2], B[2], x[2][2000], y[2000], a;
  
  limit=Bars-counted_bars;
  for(q=0; q<limit; q++)
   {
     
   ArrayInitialize(X,0);
   ArrayInitialize(Y,0);   
   ArrayInitialize(B,0);   
   ArrayInitialize(x,0);
   ArrayInitialize(y,0);  
   if (Show_nNoncomm==true){N=1;}
   
   if (Show_nOperators==true){N=2;}
   if (Show_nNonrep==true){N=3;}
     if (Show_nOI==true){N=4;}
//===========================================
for (i=0; i<=period; i++) {
x[0][i]=1;
x[1][i]=iCustom(NULL,0,"Meta COT Net Position", Show_nNoncomm,Show_nOperators,Show_nNonrep,Show_nOI,N,i+q)  ;
y[i]=   Close[i+q]-Close[i+q+1];
}
//===========================================
  for (k=1; k<=period; k++) {
  for (j=0; j<=1; j++) {
  for (i=0; i<=1; i++) { 
   X[i][j]=x[j][k]*x[i][k]+X[i][j];   
   }
   Y[j]=y[k]*x[j][k]+Y[j];
   }}  
//===========================================  
k=0; 
 j=1; 
  a=X[k][j]/X[k][k];
  for (i=0; i<=3; i++){
  X[i][j]=X[i][j]-X[i][k]*a; 
  }
  Y[j]=Y[j]-Y[k]*a;

//==========================================  
for (k=2; k>=1; k--){
a=0;
for (i=1; i>=k; i--){
a=X[i][k-1]*B[i]+a;
}
B[k-1]=(Y[k-1]-a)/X[k-1][k-1];
}
//=========================================


   A[q]=B[0]+B[1]*iCustom(NULL,0,"Meta COT Net Position", Show_nNoncomm,Show_nOperators,Show_nNonrep,Show_nOI,N,q)  ;
  
   }


//}
//=========================================

   return(0);
  }
//+------------------------------------------------------------------+